import Picker from 'vanilla-picker';
import { cached, tracked } from '@glimmer/tracking';
import { registerDestructor } from '@ember/destroyable';
import { getOwner } from '@ember/application';
import Modifier from 'ember-modifier';

function _initializerDefineProperty(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}
function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object.keys(descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;
  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }
  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);
  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }
  if (desc.initializer === void 0) {
    Object.defineProperty(target, property, desc);
    desc = null;
  }
  return desc;
}

var _class, _descriptor;
let PickerModifier = (_class = class PickerModifier extends Modifier {
  get _config() {
    const config = getOwner(this).resolveRegistration('config:environment') || {};
    return config['ember-picker'] || {};
  }
  constructor() {
    super(...arguments);
    /**
     * The picker instance
     */
    _initializerDefineProperty(this, "picker", _descriptor, this);
    registerDestructor(this, () => this.picker.destroy());
  }

  /**
   * @argument parent
   * @type {HtmlElement} HTML Element
   */
  _defaultOptions(element) {
    return {
      parent: element
    };
  }
  _getArgs(positional, named) {
    return Object.keys(named).length ? named : positional[0] || {};
  }
  _options(element, positional, named) {
    const options = this._defaultOptions(element);
    Object.assign(options, this._config, this._getArgs(positional, named));
    return options;
  }
  modify(element, positional, named) {
    const options = this._options(element, positional, named);
    this.picker = new Picker(options);
    if (options.registerAPI && typeof options.registerAPI === 'function') {
      options.registerAPI(this.picker);
    }
  }
}, (_descriptor = _applyDecoratedDescriptor(_class.prototype, "picker", [tracked], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
}), _applyDecoratedDescriptor(_class.prototype, "_config", [cached], Object.getOwnPropertyDescriptor(_class.prototype, "_config"), _class.prototype)), _class);

export { PickerModifier as default };
//# sourceMappingURL=picker.js.map
